﻿using System;
namespace DF
{
	public class JoueurHumainP4 : Joueur
	{
		public override float Nbitmoy
		{
			get
			{
				return 1F;
			}
		}
		public override void NouvellePartie()
		{
		}

		public override int Jouer(Position p, bool affichage)
		{
			if  (p is PositionP4)
			{
				PositionP4 p4 = (PositionP4)p;


				int k;
				do
				{
					Console.WriteLine("Choisissez votre colonne :");
					string s = Console.ReadLine();
					k = -10;
					if (s.Length == 1)
					{
						k = s[0] - 'a' + 1;
					}
				}
				while (k < 1 || k > PositionP4.nbCo || !(p4.cases[PositionP4.nbLi - 1, k - 1] == 0));
				k--;
				int rep = 0;
				for (int i = 0; i < k; i++)
				{
					if (p4.cases[PositionP4.nbLi - 1, i] == 0) rep++;
				}
				return rep;
			}
			else {
				PositionP4biz p4 = (PositionP4biz)p;
				int k;
				do
				{
					Console.WriteLine("Choisissez votre colonne :");
					string s = Console.ReadLine();
					k = -10;
					if (s.Length == 1)
					{
						k = s[0] - 'a' + 1;
					}
				}
				while (k < 1 || k > PositionP4biz.nbCo || !(p4.cases[PositionP4biz.nbLi - 1, k - 1] == 0));
				k--;
				int rep = 0;
				for (int i = 0; i < k; i++)
				{
					if (p4.cases[PositionP4biz.nbLi - 1, i] == 0) rep++;
				}
				return rep;
			}
	}
	}

	public class JoueurHumainHex : Joueur
	{

		public override void NouvellePartie()
		{
		}

		public override float Nbitmoy
		{
			get
			{
				return 1F;
			}
		}

		public override int Jouer(Position p, bool affichage)
		{
			PositionHex ph = (PositionHex)p;

			bool ok = false;
			int i = 0, j = 0;
			do
			{
				Console.WriteLine("Donner le couple (colonne,ligne) :");
				string s = Console.ReadLine();
				s = s.ToLower();
				if (s.Length >= 2)
				{
					j = (int)s[0] - (int)'a';
					string ss = s.Substring(1);
					ok = int.TryParse(ss, out i);
					if (ok && j >= 0 && j < PositionHex.nbCo && i >= 1 && i <= PositionHex.nbLi)
					{
						ok = false;
						if (ph.cases[i - 1, j] == 0) { ok = true; }
					}
				}
			}
			while (!ok);

			int compteur = -1;
			for (int k = 0; k <= i - 1; k++)
			{
				for (int l = 0; l < PositionHex.nbCo; l++)
				{
					if (ph.cases[k, l] == 0) { compteur++; }
					if (k == (i - 1) && l == j) { break; }
				}
			}
			return compteur;
		}
	}

	public class JoueurHasard : Joueur
	{
		static Random gen = new Random();

		public override float Nbitmoy
		{
			get
			{
				return (1F );
			}
		}

		public override void NouvellePartie()
		{
		}

		public override int Jouer(Position p,bool affichage)
		{
			return gen.Next(0, p.NbCoups);
		}

	}

}
